--- old/usr/src/uts/common/inet/tcp/tcp_input.c	2014-07-28 07:44:30.893141871 -0400
+++ new/usr/src/uts/common/inet/tcp/tcp_input.c	2014-07-28 07:44:30.899248501 -0400
@@ -1426,10 +1426,10 @@
 		tcp_listen_cnt_t *tlc = listener->tcp_listen_cnt;
 		int64_t now;
 
-		if (atomic_add_32_nv(&tlc->tlc_cnt, 1) > tlc->tlc_max + 1) {
+		if (atomic_inc_32_nv(&tlc->tlc_cnt) > tlc->tlc_max + 1) {
 			mutex_exit(&listener->tcp_eager_lock);
 			now = ddi_get_lbolt64();
-			atomic_add_32(&tlc->tlc_cnt, -1);
+			atomic_dec_32(&tlc->tlc_cnt);
 			TCP_STAT(tcps, tcp_listen_cnt_drop);
 			tlc->tlc_drop++;
 			if (now - tlc->tlc_report_time >
@@ -1871,7 +1871,7 @@
 error2:
 	freemsg(mp);
 	if (tlc_set)
-		atomic_add_32(&listener->tcp_listen_cnt->tlc_cnt, -1);
+		atomic_dec_32(&listener->tcp_listen_cnt->tlc_cnt);
 }
 
 /*
